! Subroutine estimates parameters for the complex refractive index that is covered by look-up table
subroutine sir_sca_get_coef(wavelength, iW, rMin, rMax)

  use sir_sca_store
  implicit none

  integer, intent(in) :: iW
  real*8, intent(in)  :: rMax, rMin, wavelength

  integer iGB, k, l
  real*8  radius, wavelengthRatio, x1, x2, x3

  k = 1
  wavelengthRatio = lut_wavelengthLUT/wavelength
  do iGB = 1, lut_numRadiiGridBins
    lut_coef1(iGB, iW) = 0d0
    lut_coef2(iGB, iW) = 0d0
    lut_coef3(iGB, iW) = 0d0
    if (lut_radiiGridBins(iGB).ge.rMin.and.lut_radiiGridBins(iGB).le.rMax) then
      radius = wavelengthRatio*lut_radiiGridBins(iGB)
      do l = k, lut_numRadiiGridBins - 1
        if (radius.ge.lut_radiiGridBins(l).and.radius.le.lut_radiiGridBins(l + 1)) then
          if (l.gt.1) then
            x1 = lut_radiiGridBins(l - 1)
            x2 = lut_radiiGridBins(l)
            x3 = lut_radiiGridBins(l + 1)
          else
            x1 = lut_radiiGridBins(l)
            x2 = lut_radiiGridBins(l + 1)
            x3 = lut_radiiGridBins(l + 2)
          endif
          lut_coef1(iGB, iW) = (radius - x2)*(radius - x3)/(x1 - x2)/(x1 - x3)
          lut_coef2(iGB, iW) = (radius - x1)*(radius - x3)/(x2 - x1)/(x2 - x3)
          lut_coef3(iGB, iW) = (radius - x1)*(radius - x2)/(x3 - x1)/(x3 - x2)
          k = l
          exit
        endif
      enddo
    endif
  enddo

end subroutine sir_sca_get_coef