! Subroutine reads header of look-up table file
subroutine sir_sca_read_lut_header

  use sir_sca_store
  implicit none

  integer curPos, i, istat, pos, reclRI

  inquire(iolength = reclRI) lut_wavelengthLUT

  open(unit = 33, file = lut_lutFileName(1), access = 'direct', action = 'read', form = 'unformatted', recl = reclRI)
  read(33, rec = 1) lut_wavelengthLUT
  curPos = 2
  if (lut_nonSpherical) then
    read(33, rec = curPos) lut_nonSphericalRatio(1)
    curPos = curPos + 1
  endif
  read(33, rec = curPos) lut_numRadiiGridBins
  curPos = curPos + 1
  if (allocated(lut_radiiGridBins)) deallocate(lut_radiiGridBins)
  allocate(lut_radiiGridBins(lut_numRadiiGridBins), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_header.01"
  do i = 1, lut_numRadiiGridBins
    read(33, rec = curPos) lut_radiiGridBins(i)
    curPos = curPos + 1
  enddo
  read(33, rec = curPos) lut_numScatteringAngles
  curPos = curPos + 1
  if (allocated(lut_scatteringAngles)) deallocate(lut_scatteringAngles)
  allocate(lut_scatteringAngles(lut_numScatteringAngles), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_header.02"
  do i = 1, lut_numScatteringAngles
    read(33, rec = curPos) lut_scatteringAngles(i)
    curPos = curPos + 1
  enddo
  read(33, rec = curPos) lut_numRealParts
  curPos = curPos + 1
  if (allocated(lut_realPartsLUT)) deallocate(lut_realPartsLUT)
  allocate(lut_realPartsLUT(lut_numRealParts), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_header.03"
  do i = 1, lut_numRealParts
    read(33, rec = curPos) lut_realPartsLUT(i)
    curPos = curPos + 1
  enddo
  read(33, rec = curPos) lut_numImagParts
  curPos = curPos + 1
  if (allocated(lut_imagPartsLUT)) deallocate(lut_imagPartsLUT)
  allocate(lut_imagPartsLUT(lut_numImagParts), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_header.04"
  do i = 1, lut_numImagParts
    read(33, rec = curPos) lut_imagPartsLUT(i)
    curPos = curPos + 1
  enddo
  close(33)

end subroutine sir_sca_read_lut_header