! Subroutine reads coefficients from look-up table file into memory
subroutine sir_sca_read_lut_quick

  use sir_sca_store
  implicit none

  integer iA, iGB, iL, iP, istat, iW

  call sir_sca_read_lut_header

  lut_numPSD = 4
  lut_numWavelength = 11
  lut_useNumerical = .false.

  if (allocated(lut_absCoef)) deallocate(lut_absCoef)
  allocate(lut_absCoef(lut_numPSD, lut_numWavelength, lut_numLUT), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.01"

  if (allocated(lut_absCoefFinal)) deallocate(lut_absCoefFinal)
  allocate(lut_absCoefFinal(lut_numWavelength), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.02"

  if (allocated(lut_asymmetryParamFinal)) deallocate(lut_asymmetryParamFinal)
  allocate(lut_asymmetryParamFinal(lut_numWavelength), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.03"

  if (allocated(lut_extCoef)) deallocate(lut_extCoef)
  allocate(lut_extCoef(lut_numPSD, lut_numWavelength, lut_numLUT), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.04"

  if (allocated(lut_extCoefFinal)) deallocate(lut_extCoefFinal)
  allocate(lut_extCoefFinal(lut_numWavelength), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.05"

  if (allocated(lut_coef1)) deallocate(lut_coef1)
  allocate(lut_coef1(lut_numRadiiGridBins, lut_numWavelength), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.07"

  if (allocated(lut_coef2)) deallocate(lut_coef2)
  allocate(lut_coef2(lut_numRadiiGridBins, lut_numWavelength), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.08"

  if (allocated(lut_coef3)) deallocate(lut_coef3)
  allocate(lut_coef3(lut_numRadiiGridBins, lut_numWavelength), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.09"

  if (allocated(lut_dV_dlnr)) deallocate(lut_dV_dlnr)
  allocate(lut_dV_dlnr(lut_numRadiiGridBins, lut_numPSD), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.06"

  if (allocated(lut_scaCoef)) deallocate(lut_scaCoef)
  allocate(lut_scaCoef(lut_numPSD, lut_numWavelength, lut_numLUT), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.10"

  if (allocated(lut_scaCoefFinal)) deallocate(lut_scaCoefFinal)
  allocate(lut_scaCoefFinal(lut_numWavelength), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.11"

  if (allocated(lut_ssa)) deallocate(lut_ssa)
  allocate(lut_ssa(lut_numPSD, lut_numWavelength, lut_numLUT), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.12"

  if (allocated(lut_ssaFinal)) deallocate(lut_ssaFinal)
  allocate(lut_ssaFinal(lut_numWavelength), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.13"

  if (allocated(lut_p11)) deallocate(lut_p11)
  allocate(lut_p11(lut_numScatteringAngles, lut_numPSD, lut_numWavelength, lut_numLUT), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.14"

  if (allocated(lut_p11Final)) deallocate(lut_p11Final)
  allocate(lut_p11Final(lut_numScatteringAngles, lut_numWavelength), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.15"

  if (allocated(lut_p12)) deallocate(lut_p12)
  allocate(lut_p12(lut_numScatteringAngles, lut_numPSD, lut_numWavelength, lut_numLUT), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.16"

  if (allocated(lut_p12Final)) deallocate(lut_p12Final)
  allocate(lut_p12Final(lut_numScatteringAngles, lut_numWavelength), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.17"

  if (allocated(lut_p22)) deallocate(lut_p22)
  allocate(lut_p22(lut_numScatteringAngles, lut_numPSD, lut_numWavelength, lut_numLUT), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.18"

  if (allocated(lut_p22Final)) deallocate(lut_p22Final)
  allocate(lut_p22Final(lut_numScatteringAngles, lut_numWavelength), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.19"

  if (allocated(lut_p33)) deallocate(lut_p33)
  allocate(lut_p33(lut_numScatteringAngles, lut_numPSD, lut_numWavelength, lut_numLUT), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.20"

  if (allocated(lut_p33Final)) deallocate(lut_p33Final)
  allocate(lut_p33Final(lut_numScatteringAngles, lut_numWavelength), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.21"

  if (allocated(lut_p34)) deallocate(lut_p34)
  allocate(lut_p34(lut_numScatteringAngles, lut_numPSD, lut_numWavelength, lut_numLUT), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.22"

  if (allocated(lut_p34Final)) deallocate(lut_p34Final)
  allocate(lut_p34Final(lut_numScatteringAngles, lut_numWavelength), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.23"

  if (allocated(lut_p44)) deallocate(lut_p44)
  allocate(lut_p44(lut_numScatteringAngles, lut_numPSD, lut_numWavelength, lut_numLUT), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.24"

  if (allocated(lut_p44Final)) deallocate(lut_p44Final)
  allocate(lut_p44Final(lut_numScatteringAngles, lut_numWavelength), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.25"

  if (allocated(lut_G)) deallocate(lut_G)
  allocate(lut_G(lut_numPSD), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.26"

  if (allocated(lut_reff)) deallocate(lut_reff)
  allocate(lut_reff(lut_numPSD), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.27"

  if (allocated(lut_veff)) deallocate(lut_veff)
  allocate(lut_veff(lut_numPSD), stat = istat)
  if (istat /= 0) stop "Not enough memory to allocate array. See sir_sca_read_lut_quick.28"

  lut_GFinal = 0d0
  lut_reffFinal = 0d0
  lut_veffFinal = 0d0
  do iP = 1, lut_numPSD
    lut_G(iP) = 0d0
    lut_reff(iP) = 0d0
    lut_veff(iP) = 0d0
    do iGB = 1, lut_numRadiiGridBins
      lut_dV_dlnr(iGB, iP) = 0d0
    enddo
  enddo
  do iL = 1, lut_numLUT
    do iW = 1, lut_numWavelength
      lut_absCoefFinal(iW) = 0d0
      lut_asymmetryParamFinal(iW) = 0d0
      lut_extCoefFinal(iW) = 0d0
      lut_scaCoefFinal(iW) = 0d0
      lut_ssaFinal(iW) = 0d0
      do iP = 1, lut_numPSD
        lut_absCoef(iP, iW, iL) = 0d0
        lut_extCoef(iP, iW, iL) = 0d0
        lut_scaCoef(iP, iW, iL) = 0d0
        lut_ssa(iP, iW, iL) = 0d0
        do iA = 1, lut_numScatteringAngles
          lut_p11(iA, iP, iW, iL) = 0d0
          lut_p11Final(iA, iW) = 0d0
          lut_p12(iA, iP, iW, iL) = 0d0
          lut_p12Final(iA, iW) = 0d0
          lut_p22(iA, iP, iW, iL) = 0d0
          lut_p22Final(iA, iW) = 0d0
          lut_p33(iA, iP, iW, iL) = 0d0
          lut_p33Final(iA, iW) = 0d0
          lut_p34(iA, iP, iW, iL) = 0d0
          lut_p34Final(iA, iW) = 0d0
          lut_p44(iA, iP, iW, iL) = 0d0
          lut_p44Final(iA, iW) = 0d0
        enddo
      enddo
    enddo
  enddo

end subroutine sir_sca_read_lut_quick