module sir_sca_store

  implicit none

  character(100) :: lut_lutFileName(25)

  logical :: lut_nonSpherical        ! True = use of look-up table designed for non-spherical particles
  logical :: lut_useNumerical        ! True = use direct numerical integration to compute <G>, reff, veff

  integer :: lut_numRadiiGridBins
  integer :: lut_numScatteringAngles
  integer :: lut_numRealParts
  integer :: lut_numImagParts
  integer :: lut_numLUT              ! Number of look-up tables to be loaded into memory
  integer :: lut_numPSD              ! Maximal number of covered PSD modes
  integer :: lut_numWavelength       ! Maximal number of covered wavelengths
  real*8  :: lut_pi
  real*4  :: lut_lutFraction(25)
  real*4  :: lut_nonSphericalRatio(25)
  real*4  :: lut_wavelengthLUT

  real*4, allocatable, dimension(:)          :: lut_radiiGridBins
  real*4, allocatable, dimension(:)          :: lut_scatteringAngles
  real*4, allocatable, dimension(:)          :: lut_realPartsLUT
  real*4, allocatable, dimension(:)          :: lut_imagPartsLUT
  real*4, allocatable, dimension(:)          :: lut_realPartRecord
  real*4, allocatable, dimension(:)          :: lut_imagPartRecord
  real*4, allocatable, dimension(:, :, :)    :: lut_Cext
  real*4, allocatable, dimension(:, :, :)    :: lut_Csca
  real*4, allocatable, dimension(:, :, :, :) :: lut_C11
  real*4, allocatable, dimension(:, :, :, :) :: lut_C12
  real*4, allocatable, dimension(:, :, :, :) :: lut_C22
  real*4, allocatable, dimension(:, :, :, :) :: lut_C33
  real*4, allocatable, dimension(:, :, :, :) :: lut_C34
  real*4, allocatable, dimension(:, :, :, :) :: lut_C44

  real*8, allocatable, dimension(:, :, :)    :: lut_absCoef
  real*8, allocatable, dimension(:)          :: lut_absCoefFinal
  real*8, allocatable, dimension(:)          :: lut_asymmetryParamFinal
  real*8, allocatable, dimension(:, :)       :: lut_coef1
  real*8, allocatable, dimension(:, :)       :: lut_coef2
  real*8, allocatable, dimension(:, :)       :: lut_coef3
  real*8, allocatable, dimension(:, :)       :: lut_dV_dlnr
  real*8, allocatable, dimension(:, :, :)    :: lut_extCoef
  real*8, allocatable, dimension(:)          :: lut_extCoefFinal
  real*8, allocatable, dimension(:, :, :)    :: lut_scaCoef
  real*8, allocatable, dimension(:)          :: lut_scaCoefFinal
  real*8, allocatable, dimension(:, :, :)    :: lut_ssa
  real*8, allocatable, dimension(:)          :: lut_ssaFinal
  real*8, allocatable, dimension(:, :, :, :) :: lut_p11
  real*8, allocatable, dimension(:, :)       :: lut_p11Final
  real*8, allocatable, dimension(:, :, :, :) :: lut_p12
  real*8, allocatable, dimension(:, :)       :: lut_p12Final
  real*8, allocatable, dimension(:, :, :, :) :: lut_p22
  real*8, allocatable, dimension(:, :)       :: lut_p22Final
  real*8, allocatable, dimension(:, :, :, :) :: lut_p33
  real*8, allocatable, dimension(:, :)       :: lut_p33Final
  real*8, allocatable, dimension(:, :, :, :) :: lut_p34
  real*8, allocatable, dimension(:, :)       :: lut_p34Final
  real*8, allocatable, dimension(:, :, :, :) :: lut_p44
  real*8, allocatable, dimension(:, :)       :: lut_p44Final

  real*8, allocatable, dimension(:)       :: lut_G
  real*8                                  :: lut_GFinal
  real*8, allocatable, dimension(:)       :: lut_reff
  real*8                                  :: lut_reffFinal
  real*8, allocatable, dimension(:)       :: lut_veff
  real*8                                  :: lut_veffFinal

  save

end module sir_sca_store