function [coef1, coef2, coef3, radiusIndexMin] = GetCoef(radiiGridBins, rMin, rMax, wavelengthRatio)
  k = int32(1);
  numberRadiiGridBins = int32(size(radiiGridBins, 1));
  coef1 = zeros(1, numberRadiiGridBins);
  coef2 = zeros(1, numberRadiiGridBins);
  coef3 = zeros(1, numberRadiiGridBins);
  bRadiusIndexNeedsInit = true;
  radiusIndex           = int32(zeros(1, numberRadiiGridBins));
  radiusIndexMin        = int32(-1);
  radiusWavelengthRatio = wavelengthRatio*radiiGridBins(:);
  for i = 1 : numberRadiiGridBins
    radiusIndex(i) = -1;
    if radiiGridBins(i) >= rMin && radiiGridBins(i) <= rMax
      for l = k : numberRadiiGridBins - 1
        if radiusWavelengthRatio(i) >= radiiGridBins(l) && radiusWavelengthRatio(i) <= radiiGridBins(l + 1)
          k = l;  radiusIndex(i) = l;
          if bRadiusIndexNeedsInit
            radiusIndexMin = i;  bRadiusIndexNeedsInit = false;
          end
          if l > 1
            x1 = radiiGridBins(l - 1); x2 = radiiGridBins(l);     x3 = radiiGridBins(l + 1);
          else
            x1 = radiiGridBins(l);     x2 = radiiGridBins(l + 1); x3 = radiiGridBins(l + 2);
          end
          coef1(i) = (radiusWavelengthRatio(i) - x2)*(radiusWavelengthRatio(i) - x3)/(x1 - x2)/(x1 - x3);
          coef2(i) = (radiusWavelengthRatio(i) - x1)*(radiusWavelengthRatio(i) - x3)/(x2 - x1)/(x2 - x3);
          coef3(i) = (radiusWavelengthRatio(i) - x1)*(radiusWavelengthRatio(i) - x2)/(x3 - x1)/(x3 - x2);
          break;
        end
      end
    end
  end
end