function [l0,l1,l2,ixs] = quad_interpolator_coefficients(xx,xout);
% quadratic interpolation for one dimension
% assumes xx is increasing!!!

% find 3 points closest to xout without going past ends of array
nx = length(xx);
[mn,ix] = min(abs(xx-xout));
ix0 = min([max([ix-1,1]),nx-2]);
ix1 = ix0+1;
ix2 = ix0+2;
ixs = [ix0,ix1,ix2];

% find the 3 Lagrange coefficients
l0 = (xout-xx(ix1))*(xout-xx(ix2)) / ( (xx(ix0)-xx(ix1))*(xx(ix0)-xx(ix2)) );
l1 = (xout-xx(ix0))*(xout-xx(ix2)) / ( (xx(ix1)-xx(ix0))*(xx(ix1)-xx(ix2)) );
l2 = (xout-xx(ix0))*(xout-xx(ix1)) / ( (xx(ix2)-xx(ix0))*(xx(ix2)-xx(ix1)) );

end